config/routes.rb
Rails.application.routes.draw do

  devise_for :users
  root to: 'products#index'

  namespace :admin do
    resources :products
  end

  resources :products, only: [:index, :show]

  get '/change_locale/:locale', to: 'settings#change_locale', as: :change_locale

end

app/models/product.rb
class Product < ActiveRecord::Base
	enum category: [ :action, :adventure, :shooter, :horror ]

	validates_presence_of :name, :description_en, :description_pt

	after_initialize :increment_sku

	validate :both_description_fields_required

	def self.search(search={})
		result = Product.all

		result = result.where("lower(name) LIKE :search or 
													 lower(description_en) LIKE :search or 
													 lower(description_pt) LIKE :search", search: "%#{search[:name].downcase}%") if search[:name].present?
		result = result.where(category: search[:category]) if search[:category].present?

		result
	end

	private
	def increment_sku
		self.sku ||= Product.order(:sku).last.try(:sku).to_i + 1
	end

  def both_description_fields_required
  	reminder_message = "#{I18n.t :remember}"
    errors.add(:description_en, reminder_message) if description_pt.blank?
    errors.add(:description_pt, reminder_message) if description_en.blank?
  end
end

app/models/user.rb
class User < ActiveRecord::Base
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :trackable, :validatable
end

app/controllers/admin/products_controller.rb
class Admin::ProductsController < ApplicationController
  before_action :set_product, only: [:show, :edit, :update, :destroy]
  before_action :authenticate_user!

  def index
    @products = Product.all
  end

  def show
  end

  def new
    @product = Product.new
  end

  def edit
  end

  def create
    @product = Product.new(product_params)

    if @product.save
      redirect_to admin_products_url, notice: 'Product was successfully created.'
    else
      render :new
    end
  end

  def update
    if @product.update(product_params)
      redirect_to admin_product_url(@product), notice: 'Product was successfully updated.'
    else
      render :edit
    end
  end

  def destroy
    @product.destroy
    redirect_to admin_products_url, notice: 'Product was successfully destroyed.'
  end

  private
  def set_product
    @product = Product.find(params[:id])
  end

  def product_params
    params.require(:product).permit(:name, :description_en, :description_pt, :category, :published, :boxshot, :sku)
  end
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base

  protect_from_forgery with: :exception

	before_action :set_locale

	# ==================================================================
	# O idioma do site estava variando de acordo com a URL, mas troquei
	# por conta dos requisitos do desafio. De acordo com o Rails guides,
	# o ideal seria deixar na URL para tornar o processo transparente.
	#
	# Por exemplo, se alguem mandasse a URL do site para um amigo, ele
	# veria exatamente o mesmo conteúdo; isso não acontece quando
	# usamos cookies.
	# ==================================================================

	def set_locale
	  if cookies[:educator_locale] && I18n.available_locales.include?(cookies[:educator_locale].to_sym)
	    locale = cookies[:educator_locale].to_sym
	  else
	    locale = I18n.default_locale
	    cookies.permanent[:educator_locale] = locale
	  end

	  I18n.locale = locale
	end
end

app/controllers/products_controller.rb
class ProductsController < ApplicationController

  def index
    @products = Product.search(params)
  end

  def show
  	@product = Product.find(params[:id])
  end

end

app/controllers/settings_controller.rb
class SettingsController < ApplicationController

  def change_locale
    locale = params[:locale].to_s.strip.to_sym
    locale = I18n.default_locale unless I18n.available_locales.include?(locale)

    cookies.permanent[:educator_locale] = locale

    redirect_to request.referer || root_url
  end

end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/products_helper.rb
module ProductsHelper
	def translated_product_categories
		Product.categories.map { |key, value| [translated_product_category(key), value] }.to_h
	end

	def translated_product_category(category)
		I18n.t :"product_categories.#{category}"
	end
end

app/views/admin/products/_form.html.erb
<%= simple_form_for [:admin, @product] do |f| %>
  <%= f.error_notification %>

  <div class="form-inputs">
    <%= f.input :name, label: "#{I18n.t :name}" %>
    <%= f.input :category, as: :select, collection: Product.categories.keys, label: "#{I18n.t :category}" %>
    <%= f.input :sku %>
    <button type="button" onClick="changeLanguage()"><%= I18n.t :change_language %></button>
    <div id="description_en">
      <%= f.input :description_en, label: "#{I18n.t :description} EN"%>
    </div>
    <div id="description_pt" style="display: none;">
      <%= f.input :description_pt, label: "#{I18n.t :description} PT"%>
    </div>
    <%= f.input :boxshot %>
    <%= f.input :published, as: :boolean, label: "#{I18n.t :published}" %>
  </div>

  <div class="form-actions">
    <%= f.button :submit, "#{I18n.t :submit}" %>
  </div>
<% end %>

app/views/admin/products/edit.html.erb
<h1><%= I18n.t :edit_product %></h1>

<%= render 'form' %>

<%= link_to "#{I18n.t :show}", admin_product_path(@product) %> |
<%= link_to "#{I18n.t :back}", admin_products_path %>

app/views/admin/products/index.html.erb
<p id="notice"><%= notice %></p>

<h1><%= I18n.t :listing_products %></h1>

<table class="table table-inverse">
  <thead>
    <tr>
      <th>SKU</th>
      <th><%= I18n.t :name %></th>
      <th><%= I18n.t :category %></th>
      <th><%= I18n.t :description %> EN</th>
      <th><%= I18n.t :description %> PT</th>
      <th><%= I18n.t :published %></th>
      <th><%= I18n.t :actions %></th>
    </tr>
  </thead>

  <tbody>
    <% @products.each do |product| %>
      <tr>
        <td><%= product.sku %></td>
        <td><%= product.name %></td>
        <td><%= translated_product_category(product.category) %></td>
        <td><%= product.description_en %></td>
        <td><%= product.description_pt %></td>
        <td><%= I18n.t :"#{product.published}" %></td>
        <td><%= link_to "#{I18n.t :show}", admin_product_path(product) %></td>
        <td><%= link_to "#{I18n.t :edit}", edit_admin_product_path(product) %></td>
        <td><%= link_to "#{I18n.t :destroy}", admin_product_path(product), method: :delete, data: { confirm: "#{I18n.t :confirmation}" } %></td>
      </tr>
    <% end %>
  </tbody>
</table>

<br>

<%= link_to "#{I18n.t :new_product}", new_admin_product_path %>

app/views/admin/products/new.html.erb
<h1><%= I18n.t :new_product %></h1>

<%= render 'form' %>

<%= link_to "#{I18n.t :back}", admin_products_path %>

app/views/admin/products/show.html.erb
<p id="notice"><%= notice %></p>

<p>
  <img src="<%= @product.boxshot %>" style="height: 340px;">
</p>

<p>
  <strong><%= I18n.t :name %>:</strong>
  <%= @product.name %>
</p>

<p>
  <strong><%= I18n.t :category %>:</strong>
  <%= translated_product_category(@product.category) %>
</p>

<p>
  <strong>SKU:</strong>
  <%= @product.sku %>
</p>

<p>
  <strong><%= I18n.t :description %> EN:</strong>
  <%= @product.description_en %>
</p>

<p>
  <strong><%= I18n.t :description %> PT:</strong>
  <%= @product.description_pt %>
</p>

<p>
  <strong><%= I18n.t :published %>:</strong>
  <%= I18n.t :"#{@product.published}" %>
</p>

<%= link_to "#{I18n.t :edit}", edit_admin_product_path(@product) %> |
<%= link_to "#{I18n.t :back}", admin_products_path %>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
	<head>
	  <title>Nuuvem</title>
	  <%= stylesheet_link_tag    'application', media: 'all', 'data-turbolinks-track' => true %>
	  <%= javascript_include_tag 'application', 'data-turbolinks-track' => true %>
	  <%= csrf_meta_tags %>
	</head>

	<body>
		<div class="container">
			<header>
				<nav class="navbar navbar-light bg-faded">
					<%= link_to "FooStore - #{I18n.t :games}", root_path, class: "navbar-brand" %>
					<%= link_to('Logout', destroy_user_session_path, :method => :delete) + " |" if current_user %> 
					<%= link_to("Admin", admin_products_path) %> | 
					<% if I18n.locale == :en %>
          	<%= link_to "#{I18n.t :portuguese}", change_locale_path(:pt) %>
					<% else %>
          	<%= link_to "#{I18n.t :english}", change_locale_path(:en) %>
					<% end %>
				</nav>
			</header>
			
			<%= yield %>

  	</div>
	</body>
</html>

app/views/products/index.html.erb
<div class="row row-offcanvas row-offcanvas-right">
  <div class="col-xs-12 col-sm-9">
    <%= form_tag(products_path, :method => "get") do %>
      <%= text_field_tag :name, params[:name], placeholder: "#{I18n.t :name}" %>
      <%= select_tag :category, options_for_select(translated_product_categories, selected: params[:category]), include_blank: true %>
      <%= submit_tag "#{I18n.t :search}" %>
    <% end %>

    <div class="jumbotron">
      <h1><%= I18n.t :introduction_title %></h1>
      <p><%= I18n.t :introduction %></p>
    </div>
    <div class="row">
      <% if @products.any? %>
        <% @products.each do |product| %>
          <div class="col-xs-6 col-lg-4" style="margin-top: 20px;">
            <%= link_to product_path(product.id) do %>
              <div class="thumbnail">
                <img class="img-responsive" src="<%= product.boxshot %>" alt="<%= product.name %>" style="width: 100%; height: 340px;">
              </div>
            <% end %>
          </div>
        <% end %>
      <% else %>
        <div><%= I18n.t :no_products %></div>
      <% end %>
    </div>
  </div>
</div>

app/views/products/show.html.erb
<div class="container">
  <div class="row">
   <div class="col-md-6">
    <img src="<%= @product.boxshot %>" style="height: 340px;">
   </div>
   <div class="col-md-6">
    <% unless @product.published? %>
      <%= I18n.t :unpublished %>
    <% end %>
   	<h2><%= @product.name %></h2>
    <h3><%= translated_product_category(@product.category) %></h3>
   	<div>SKU: <%= @product.sku %></div>
    <% if I18n.locale == :en %>
   	  <div><%= @product.description_en %></div>
    <% else %>
      <div><%= @product.description_pt %></div>
    <% end %>
   </div>
  </div>
 </div>

 <%= link_to "#{I18n.t :back}", products_path, class: "btn btn-default"%>